﻿Type=Activity
Version=2.00
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
Dim fileimg, folder As Bitmap
Dim lw,lh,delta As Int
Dim datalist, btntaglist As List
Dim treeview As ScrollView
Dim rootnode, nd() As Node

End Sub

Sub Activity_Create(FirstTime As Boolean)
Dim st As String

treeview.Initialize2(100%y,"treeview")
treeview.Panel.Initialize("")
Activity.AddView(treeview,0,0,Activity.Width,Activity.Height)
lw = 40%x
lh = 8%y
folder.Initialize(File.DirAssets,"folder2.png")
fileimg.Initialize(File.DirAssets,"file.png")
st = File.DirRootExternal
rootnode.Initialize("Tree",Null,0,lw,lh,"Sdcard:",folder,st,"plus" )
treeview.Panel.AddView(rootnode.AsView,0,0,lw,lh)

End Sub

Public Sub get_data(dir As String)  ' this part is now for files management, can be adapted to other kinds of data to be shown as tree

datalist.Initialize 
datalist =  File.ListFiles(dir)

btntaglist.Initialize   
For i = 0 To datalist.Size - 1
	If File.IsDirectory(dir, datalist.Get(i)) Then 
		btntaglist.Add("plus") 
	Else 
		btntaglist.Add("")
	End If
Next
End Sub

Sub Node_Close(tn As Node)
delta = 0   ' a counter for collapsed lines       
remove_children(tn)
move_nodes( tn.AsView.Top ,-delta) ' move lower nodes up
End Sub

Sub Node_Open(tn As Node)
Dim tbmp As Bitmap
get_data(tn.getTag)
Dim nd(datalist.Size) As Node

move_nodes( tn.TN.pnl.Top ,datalist.Size)

For i = 0 To datalist.Size-1         ' assign data items to new nodes
	If btntaglist.Get(i) = "plus" Then 
		tbmp = folder
	Else 
		tbmp = fileimg
	End If
	nd(i).Initialize("Tree",tn,tn.TN.level + 1,lw,lh,datalist.Get(i),tbmp, tn.getTag & "/" & datalist.Get(i), btntaglist.Get(i) )
	treeview.Panel.AddView(nd(i).AsView, nd(i).TN.level*lh,tn.AsView.Top +(i+1)*lh,lw,lh)
Next
End Sub

Sub move_nodes( top As Int,lines As Int)
Dim v As View
For j = 0 To treeview.Panel.NumberOfViews - 1  
	v = treeview.Panel.GetView(j)
	If v.top  > top Then
		v.top = v.top + lines * lh
	End If
Next
treeview.Panel.Height = treeview.Panel.Height + lines * lh
End Sub

Sub remove_children(Rnode As Node)  ' close a node
Dim delnode As Node

For i =  Rnode.TN.children.Size - 1 To 0 Step - 1
	delta = delta + 1
 	delnode = Rnode.TN.children.Get(i)
								 ' recursion if the sub node is open
	If delnode.TN.btn.tag = "minus" Then remove_children(delnode) 
	delnode.TN.pnl.RemoveView  ' then delete it
Next
Rnode.TN.children.Clear  ' zero the child list in the closing node
End Sub

Sub Node_Click(tn As Node)
'in this sub do what you want with this selected item, for example - color the panel
tn.TN.pnl.Color = Colors.blue
End Sub

Sub Node_LongClick(tn As Node)
'in this sub do what you want with this selected item, for example - color the panel
tn.TN.pnl.Color = Colors.black
End Sub